//----------------------------------------------------------------------//
//je[u															//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <System.DateUtils.hpp>
#include "holiday.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
const _TCHAR *WeekStrJ[7]
	 = {_T(""), _T(""), _T(""), _T(""), _T(""), _T(""), _T("y")};
const _TCHAR *WeekStrE[7]
	 = {_T("Sunday"), _T("Monday"), _T("Tuesday"), _T("Wednesday"),
	    _T("Thursday"), _T("Friday"), _T("Saturday")};

const _TCHAR *MonthStrE[12]
	 = {_T("January"), _T("February"), _T("March"), _T("April"), _T("May"), _T("June"),
	    _T("July"), _T("August"), _T("September"), _T("October"), _T("November"), _T("December")};

//--------------------------------------
//wN̓擾
//--------------------------------------
int get_dayn(int y, int m)
{
	int d;
	switch (m) {
	case 2:
    	if ((y%4==0 && y%100!=0) || y%400==0) d = 29; else d = 28;
		break;
	case 4: case 6: case 9: case 11:
		d = 30;
		break;
	default:
		d = 31;
	}
	return d;
}

//--------------------------------------
//wN̗j擾
// 1:,2: ` 7:y
//--------------------------------------
int get_wek(int y, int m, int d)
{
	if (m<3) {
		y--; m += 12;
	}
	return ((y + y/4 - y/100 + y/400 + (26*m + 16)/10 + d) % 7) + 1;
}

//--------------------------------------
//wN̑n wj(1`7)̓擾
//--------------------------------------
int get_wday(int y, int m, int w, int n)
{
	int d = 1;
	while (get_wek(y, m, d)!=w) d++;	//1 wj߂

	int i = 1;
	while (i<n) {
		d += 7; i++;
	}
	return d;
}


//---------------------------------------------------------------------------
// je[u NX
//---------------------------------------------------------------------------
HolidayTable::HolidayTable()
{
	Year  = 0;
	Count = 0;
}

//---------------------------------------------------------------------------
//wN̏je[u쐬
//---------------------------------------------------------------------------
void HolidayTable::InitTable(unsigned short y)
{
	Year  = y;
	Count = 0;

	//
	Add( 1, 1, _T(""));

	//l̓
	unsigned short d = (y<2000)? 15 : get_wday(y, 1, wixMON, 2);
	Add( 1, d, _T("l̓"));

	//LO̓
	Add( 2,11, _T("LO̓"));

	//Vca()
	if (y>=2020) Add( 2,23, _T("Vca"));

	//t̓
	d = (20843100 + (y - 1980)*242194)/1000000 - (y - 1980)/4;
	Add( 3, d, _T("t̓"));

	//݂ǂ̓ -> a̓
	if (y>=1989) Add( 4,29, (y<2007)? _T("݂ǂ̓") : _T("a̓"));

	//ʂ̓ (2019̂)
	if (y==2019) Add( 5, 1, _T("ʂ̓"));

	//@LO
	Add( 5, 3, _T("@LO"));

	//݂ǂ̓
	if (y>=2007) Add( 5, 4, _T("݂ǂ̓"));

	//ǂ̓
	Add( 5, 5, _T("ǂ̓"));

	//C̓(2020/2021̈ړɑΉ)
	if (y>=1996) {
		d = (y<2003)? 20 : (y==2020)? 23 : (y==2021)? 22 : get_wday(y, 7, wixMON, 3);
		Add( 7, d, _T("C̓"));
	}

	//X|[c̓(2020/2021̈ړ)
	if (y==2020 || y==2021) Add( 7, (y==2020)? 24 : 23, _T("X|[c̓"));

	//R̓(2020/2021̈ړɑΉ)
	if (y>=2016) {
		d = (y==2020)? 10 : (y==2021)? 8 : 11;
		Add( 8, d, _T("R̓"));
	}

	//hV̓
	d = (y<2003)? 15 : get_wday(y, 9, wixMON, 3);
	Add( 9, d, _T("hV̓"));

	//H̓
	d = (23248800 + (y - 1980)*242194)/1000000 - (y - 1980)/4;
	Add( 9, d, _T("H̓"));

	//X|[c̓(2020/2021)
	if (y!=2020 && y!=2021) {
		d = (y<2000)? 10 : get_wday(y, 10, wixMON, 2);
		Add(10, d, (y>=2020)? _T("X|[c̓") : _T("̈̓"));
	}

	//ʗ琳a̋V (2019̂)
	if (y==2019) Add(10,22, _T("ʗ琳a̋V"));

	//̓
	Add(11, 3, _T("̓"));

	//ΘJӂ̓
	Add(11,23, _T("ΘJӂ̓"));

	//Vca()
	if (y>=1989 && y<2019) Add(12,23, _T("Vca"));

	//jj̏ꍇ
	for (int i=0; i<Count; i++) {
		unsigned short m = Table[i].m;
		unsigned short d = Table[i].d;
		if (get_wek(y, m, d)==wixSUN) {
			for (;;) {
				TDate dt = TDate(y, m, d);
				dt = IncDay(dt, 1);
				DecodeDate(dt, y, m, d);

				if (y<2007) break;
					//(<2007 ̓j̏ꍇ͐Uւx
				if (!IsHoliday(y, m, d, NULL)) break;
					//(>=2007 ł߂ȕjvłȂ
			}
			Add(m, d, _T("Uւx"));
		}
	}

	//jɋ܂ꂽ͍̋x
	for (int i=0; i<Count; i++) {
		unsigned short yi = y;
		unsigned short mi = Table[i].m;
		unsigned short di = Table[i].d;
		//
		TDate dt = TDate(yi, mi, di);
		dt = IncDay(dt, 1);
		DecodeDate(dt, yi, mi, di);
		//?
		if (!IsHoliday(yi, mi, di, NULL) && get_wek(yi, mi, di)!=wixSUN) {
			unsigned short m = mi;
			unsigned short d = di;
			dt = IncDay(dt, 1);
			DecodeDate(dt, yi, mi, di);
			if (yi==y && IsHoliday(yi, mi, di, NULL)) Add(m, d, _T("̋x"));
		}
	}
}

//---------------------------------------------------------------------------
//e[uɏjǉ
//---------------------------------------------------------------------------
void HolidayTable::Add(unsigned short m, unsigned short d, const _TCHAR *name)
{
	Table[Count].m = m;
	Table[Count].d = d;
	_tcscpy(Table[Count].name, name);
	Count++;
}

//---------------------------------------------------------------------------
//Nɂw茎̏j
// ߂l
//  true:j/ false:jł͂Ȃ
//  name: NULL łȂΏjԂ
//---------------------------------------------------------------------------
bool HolidayTable::IsHoliday(unsigned short y, unsigned short m, unsigned short d, _TCHAR *name)
{
	if (y!=Year) InitTable(y);

	int n = -1;
	for (int i=0; i<Count; i++) {
		if (Table[i].m==m && Table[i].d==d) {
			n = i; break;
		}
	}

	if (name!=NULL) {
		if (n==-1)
			name[0]= '\0';
		else
			_tcscpy(name, Table[n].name);
	}
	return (n!=-1);
}
//---------------------------------------------------------------------------
